# Summary

- [Introduction](README.md)
  - [Approaches](about.md)
  - [Installation](install.md)
- [Features](features.md)
- Tutorials
  - [Simple Server](tutorial/todo-list.md)
  - [Middleware](use/middleware.md)
  - [Custom Server](tutorial/custom-server.md)
  - [Dynamic Server](tutorial/dynamic.md)
  - Security
    - [Authentication](tutorial/authentication/README.md)
    - [OAuth2](tutorial/oauth2/README.md)
    - [Composition](tutorial/composed-auth/README.md)
- Use-Cases
  - [Options and commands](usage/swagger.md)
  - [Serve UI](usage/serve_ui.md)
  - [Validate](usage/validate.md)
  - Generate
    - [API Client](generate/client.md)
    - [API Server](generate/server.md)
      - [Usage](use/server.md)
    - [API Model](generate/model.md)
      - [Model generation rules](use/schemas.md)  
  - [Spec from source](generate/spec.md)
    - [swagger:meta](generate/spec/meta.md)
    - [swagger:route](generate/spec/route.md)
    - [swagger:params](generate/spec/params.md)
    - [swagger:operation](generate/spec/operation.md)
    - [swagger:response](generate/spec/response.md)
    - [swagger:model](generate/spec/model.md)
    - [swagger:allOf](generate/spec/allOf.md)
    - [swagger:strfmt](generate/spec/strfmt.md)
    - [swagger:discriminated](generate/spec/discriminated.md)
    - [swagger:ignore](generate/spec/ignore.md)
- [Custom generation](use/template_layout.md)
  - [Custom templates](generate/templates.md)
- [CLI autocompletion](cli_helpers.md)
- [FAQ](faq/README.md)
  - [Installation,setup and environment](faq/faq_setup.md)
  - [Model generation](faq/faq_model.md)
  - [Server generation & customization](faq/faq_server.md)
  - [Client generation](faq/faq_client.md)
  - [Spec generation from source](faq/faq_spec.md)
  - [API testing](faq/faq_testing.md)
  - [Documenting your API](faq/faq_documenting.md)
